# NOTE
# - release tarballs: http://getcomposer.org/download/

# Conditional build:
%bcond_with	bootstrap		# build boostrap

%define		rel		14
#define		githash	5744981
# $ git rev-list 1.0.0-alpha10..%{githash} --count
#define		commits	216
%define		subver	alpha10
%define		php_min_version 5.3.4
%include	/usr/lib/rpm/macros.php
Summary:	Dependency Manager for PHP
Name:		composer
Version:	1.0.0
Release:	%{rel}.%{subver}%{?commits:.%{commits}}%{?githash:.g%{githash}}
License:	MIT
Group:		Development/Languages/PHP
#Source0:       https://github.com/composer/composer/archive/%{githash}/%{name}-%{version}-%{subver}-%{commits}-g%{githash}.tar.gz
Source0:	https://github.com/composer/composer/archive/%{version}-%{subver}/%{name}-%{version}-%{subver}.tar.gz
# Source0-md5:	e821eec53cbb98871b4cccfc82a6bae7
%if %{with bootstrap}
Source1:	http://getcomposer.org/download/%{version}-alpha8/%{name}.phar
# Source1-md5:	df1001975035f07d09307bf1f1e62584
%endif
Source2:	https://raw.githubusercontent.com/iArren/%{name}-bash-completion/86a8129/composer
# Source2-md5:	cdeebf0a0da1fd07d0fd886d0461642e
Patch0:		nogit.patch
Patch1:		no-vendors.patch
Patch2:		autoload-config.patch
Patch3:		update-memory-limit.patch
Patch4:		svn-ignore-externals.patch
URL:		http://www.getcomposer.org/
BuildRequires:	%{php_name}-cli
BuildRequires:	%{php_name}-ctype
BuildRequires:	%{php_name}-filter
BuildRequires:	%{php_name}-hash
BuildRequires:	%{php_name}-json
BuildRequires:	%{php_name}-openssl
BuildRequires:	%{php_name}-phar
BuildRequires:	%{php_name}-zip
BuildRequires:	%{php_name}-zlib
BuildRequires:	/usr/bin/phar
BuildRequires:	php-devel
BuildRequires:	rpm-php-pearprov >= 4.4.2-11
BuildRequires:	rpmbuild(macros) >= 1.673
%if %{without bootstrap}
BuildRequires:	%{name}
BuildRequires:	php-symfony2-Console >= 2.3
BuildRequires:	php-symfony2-Finder >= 2.2
%endif
Requires:	php(core) >= %{php_min_version}
Requires:	php(ctype)
Requires:	php(date)
Requires:	php(filter)
Requires:	php(hash)
Requires:	php(json)
Requires:	php(openssl)
Requires:	php(pcre)
Requires:	php(phar)
Requires:	php(posix)
Requires:	php(simplexml)
Requires:	php(spl)
Requires:	php(zip)
Requires:	php(zlib)
%if %{without bootstrap}
Requires:	php-justinrainbow-json-schema >= 1.4
Requires:	php-seld-jsonlint >= 1.1.2
Requires:	php-symfony2-Console >= 2.5
Requires:	php-symfony2-Finder >= 2.2
Requires:	php-symfony2-Process >= 2.1
%endif
Suggests:	bash-completion-%{name}
Suggests:	git-core
Suggests:	mercurial
Suggests:	subversion
BuildArch:	noarch
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		_appdir		%{_datadir}/%{name}

%description
Composer is a tool for dependency management in PHP.

Composer helps you declare, manage and install dependencies of PHP
projects, ensuring you have the right stack everywhere.

%package -n bash-completion-%{name}
Summary:	Bash completion for Composer
Summary(pl.UTF-8):	bashowe uzupełnianie nazw dla Composera
Group:		Applications/Shells
Requires:	%{name}
Requires:	bash-completion >= 2.0

%description -n bash-completion-%{name}
Bash completion for Composer package and dependency manager.

%description -n bash-completion-%{name} -l pl.UTF-8
Pakiet ten dostarcza bashowe uzupełnianie nazw dla Composera.

%prep
%setup -qc -n %{name}-%{version}-%{release}
mv composer-*/* .
%patch0 -p1
%{!?with_bootstrap:%patch1 -p1}
%patch3 -p1
%patch4 -p1

mv composer.lock{,.disabled}
# NOTE: do not use %{__php} macro here, need unversioned php binary
%{__sed} -i -e '1s,^#!.*env php,#!/usr/bin/php,' bin/*

# cleanup backups after patching
find '(' -name '*~' -o -name '*.orig' ')' -print0 | xargs -0 -r -l512 rm -f

%build
%if %{with bootstrap}
composer='%{__php} %{SOURCE1}'
phar extract -f "%{SOURCE1}" -i vendor .
%else
composer=composer
%endif
if [ ! -d vendor ]; then
	COMPOSER_HOME=${PWD:=$(pwd)} \
	$composer dump-autoload -v
	%{__patch} -p1 < %{PATCH2}
fi

RELEASE_DATE=$(LC_ALL=C date) \
PACKAGE_VERSION=%{?!githash:%{version}-%{subver}}%{?githash} \
DEV_VERSION=%{!?githash:0}%{?githash:1} \
%{__php} -d phar.readonly=0 ./bin/compile

# sanity check
%{__php} composer.phar --version

install -d build
%{__php} -r '$phar = new Phar($argv[1]); $phar->extractTo($argv[2]);' composer.phar build

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{%{_bindir},%{_appdir},/var/cache/composer}
cd build
cp -a bin src res vendor $RPM_BUILD_ROOT%{_appdir}
ln -s %{_appdir}/bin/%{name} $RPM_BUILD_ROOT%{_bindir}/%{name}
chmod +x $RPM_BUILD_ROOT%{_appdir}/bin/*

install -d $RPM_BUILD_ROOT%{bash_compdir}
cp -p %{SOURCE2} $RPM_BUILD_ROOT%{bash_compdir}/composer

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(644,root,root,755)
%doc README.md CHANGELOG.md LICENSE PORTING_INFO
%attr(755,root,root) %{_bindir}/composer
%dir %{_appdir}
%dir %{_appdir}/bin
%attr(755,root,root) %{_appdir}/bin/*
%{_appdir}/res
%{_appdir}/src
%{_appdir}/vendor

# top level cachedir, create user cache dirs here manually
%dir %attr(711,root,http) /var/cache/composer

%files -n bash-completion-%{name}
%defattr(644,root,root,755)
%{bash_compdir}/composer
%changelog
* Fri Sep 18 2015 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/composer.git;a=log;h=master

* Fri Sep 18 2015 Elan Ruusamäe <glen@delfi.ee> d480457
- ignore externals on svn switch

* Thu Sep 10 2015 Elan Ruusamäe <glen@delfi.ee> df4bed0
- patch checkout not svn log

* Thu Sep 10 2015 Elan Ruusamäe <glen@delfi.ee> 833eb7f
- ignore svn externals when checking out vendors

* Wed Sep 02 2015 Elan Ruusamäe <glen@delfi.ee> 5d101a0
- use php-devel version of php for build, ensure result is unversioned

* Wed Sep 02 2015 Elan Ruusamäe <glen@delfi.ee> eaa6c53
- cosmetics

* Thu Aug 13 2015 Elan Ruusamäe <glen@delfi.ee> df35030
- BR filter

* Wed Aug 12 2015 Elan Ruusamäe <glen@delfi.ee> b0da7bb
- up to 1.0.0-alpha10

* Wed Feb 18 2015 Elan Ruusamäe <glen@delfi.ee> 9e924ff
- use json-schema >= 1.3

* Tue Feb 17 2015 Elan Ruusamäe <glen@delfi.ee> 20ba274
- up to 1.0.0-alpha9-216-g5744981

* Sat Dec 13 2014 Elan Ruusamäe <glen@delfi.ee> c3f23dc
- BR virtual php-devel

* Fri Dec 12 2014 Elan Ruusamäe <glen@delfi.ee> 826ed1f
- up to 1.0.0-alpha9

* Fri Nov 28 2014 Elan Ruusamäe <glen@delfi.ee> e3a3393
- cleanup backups after patching

* Fri Nov 28 2014 Elan Ruusamäe <glen@delfi.ee> 848ed42
- up to b23a3cd

* Tue Nov 04 2014 Elan Ruusamäe <glen@delfi.ee> fd4b4da
- add top level composer cachedir

* Sun Oct 26 2014 Elan Ruusamäe <glen@delfi.ee> 11d0b21
- up to b0cabd1, supports composer events for Composer Asset Plugin

* Tue Aug 05 2014 Elan Ruusamäe <glen@delfi.ee> f53ea84
- trailing slash

* Tue Aug 05 2014 Elan Ruusamäe <glen@delfi.ee> fbddd7d
- hhvm peardir fix (PEAR_INSTALL_DIR constant is empty)

* Tue Aug 05 2014 Elan Ruusamäe <glen@delfi.ee> 048c235
- disable memory limit for update command

* Sun Jun 22 2014 Elan Ruusamäe <glen@delfi.ee> d553497
- R zlib ext to open compressed phar archives

* Sat Jun 21 2014 Elan Ruusamäe <glen@delfi.ee> 07372a8
- release 5 (by relup.sh)

